//+------------------------------------------------------------------+
//|                                                 30pipsSystem.mq4 |
//|                                                             tsuok|
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#include <stdlib.mqh>
extern string  JUST_TO_INFORM_YOU_THAT    = "AutoLot calculate base on MMBase";
extern string  FOR                        =  "MMBase : 1=AccountBalance";
extern string  THEN                       =  "MMBase : 2=AccountEquity";
extern string  AND                        =  "MMBase : 3=AccountFreeMargin";
extern string  MaxRisk_Definition         = "0.05 means 5% by default";
extern string  CloseScrap_Or_Not          = "true = close some scrap orders";
extern string  CloseRatio_Means___________= "last-lot/1st-lot = x then close";
extern string  ___________________________= "____________Enjoy ^_^____________";
extern double  BackTestLimit  =100000;
extern int     MagicNo        = 318;
extern int     StopOutAt      = 10;
extern bool    AutoLot        = false;
extern int     MMBase         = 3;
extern double  MaxRisk        = 0.01;                       // 5% by default
extern string  ______In_Case_Not_AutoLot______="__________________________________________________";
extern double  LotSize        = 1;
extern string  ______Manual_Lot_Limitation____="__________________________________________________";
extern double  MinLot         = 0.10;
extern double  MaxLot         = 100;
extern string  _______________________________="__________________________________________________";
extern double  increasefactor = 3;
extern int     extPips        = 30;
extern int     extPipsOffset  = 0;
extern bool    AutoTakeProfit =false;
extern bool    CloseScrap     = true;
extern double  CloseRatio     = 1.5;
extern bool    ShowStatus     = true;
extern bool    ShowLineStatus = true;
extern color   LineStatus     = MediumVioletRed;
extern string  ______Open.Close_Sig_Color_____="__________________________________________________";
extern color   clOpenBuy      = Goldenrod;
extern color   clOpenSell     = MediumVioletRed;
extern color   clClose        = Black;
extern bool    PlayAudio      = true;
double extSizeRatio = 0.0125;
double Lot,RLot,initDeposite,limit;
int Slippage,hh,b=0,s=0,exPositions;
bool BlockOpen=false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
Slippage=MarketInfo(Symbol(), MODE_SPREAD);
if(Slippage==0)Slippage=MathRound((Ask-Bid)/Point);
exPositions=ExistPositions();
RLot=Lots(MaxRisk);
return(0);
}
int deinit(){return(0);}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{  if(IsTesting())limit=BackTestLimit;
   else 
   {
    OrderSelect(0,SELECT_BY_POS,MODE_HISTORY);
    initDeposite=OrderProfit();
    limit=NormalizeDouble((initDeposite*StopOutAt),0);
    if(limit<=0)limit=BackTestLimit;
   }
   
   if(HistoryTotal()>1)RLot=Lots(MaxRisk*increasefactor);

   if(exPositions!=ExistPositions()){b=0;s=0;}
	double price = (Bid + Ask) / 2;
	double keyPrice = GetKeyPrice(price);
	
	if(ExistPositions()==0||exPositions!=ExistPositions()) 
	{
	if(IsNear(price, keyPrice))
	{
		if(AutoTakeProfit)TakeProfit(keyPrice);
		if(AccountBalance()<limit)TakePosition(keyPrice);
	}
	}
	//*****************************************************************
	if(OrdersTotal()>0)
	{
   if(OrderSelect(OrdersTotal()-1,SELECT_BY_POS,MODE_TRADES)
      &&OrderSymbol()     ==Symbol()
      &&OrderMagicNumber()==MagicNo
     ){double lastprice=OrderOpenPrice();
       double lastlot  =OrderLots();
      }
   //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++   
   if(OrderSelect(0,SELECT_BY_POS,MODE_TRADES)
   &&OrderSymbol()     ==Symbol()
   &&OrderMagicNumber()==MagicNo
   ){double firstlot=OrderLots();}
   //*****************************************************************
   if((lastlot/firstlot>CloseRatio && CloseScrap)|| AccountEquity()>limit)
   {
    for(int i=OrdersTotal()-1;i>=0;i--)
    {
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)
        &&OrderSymbol()     ==Symbol()
        &&OrderMagicNumber()==MagicNo)
     {
      if(OrderLots()==firstlot)
      {
       bool ww=OrderClose(OrderTicket()
                  ,OrderLots()
                  ,OrderClosePrice()
                  ,MarketInfo(OrderSymbol(),MODE_SPREAD)
                  ,CLR_NONE);
       if(!ww)Print("Close Scrap : ",ErrorDescription(GetLastError()));
       else   Print("Close Scrap By ",CloseRatio," Ratio.");
       exPositions=ExistPositions();
       b=0;s=0;
      }
     }
    }
   }
   
   }
   {
   if(AutoLot){string detail = "\nMMBase : "+MMBase2string(MMBase)
                               +"\nMaxRisk : "+DoubleToStr(MaxRisk,2)
                               +"\nMinLot : " +DoubleToStr(MinLot,2)
                               +"\nMaxLot : " +DoubleToStr(MaxLot,2)
                               ;}
   else       {detail = "\nLotSize : "+DoubleToStr(LotSize,2);}   
   }
   {
   if(CloseScrap){string cc = "\nCloseRatio : "+DoubleToStr(CloseRatio,2);}
   else                  cc = "";             
   }         
   //********************************************************************************************
   if(ShowStatus)
   {  
      //*****************************************************************************************
      Comment(
             "\nAutoLot : " ,bool2string(AutoLot)
             ,detail
             ,"\n----------------"
             ,"\nCloseScrap : ",bool2string(CloseScrap)
             ,cc
             ,"\n----------------"
             ,"\nPlayAudio : ",bool2string(PlayAudio)
             ,"\n----------------"
             ,"\nextPips : ",extPips
             ,"\nextPipsOffset : ",extPipsOffset
             ,"\nAutoTakeProfit : ",bool2string(AutoTakeProfit)
             ,"\nIsNear(price, keyPrice) : ",bool2string(IsNear(price, keyPrice))
            );
      //*****************************************************************************************
   }         
   else 
   {Comment("");}
   
   
   if(ShowLineStatus)
   {double Expect1=NormalizeDouble(MathAbs(lastprice-extPips*Point),Digits);
    double Expect2=NormalizeDouble(MathAbs(lastprice+extPips*Point),Digits);
   //*****************************************************************************************
   MoveObject("Expect1",OBJ_HLINE,Time[0],Expect1,Time[0],Expect1,LineStatus,1,STYLE_SOLID);
   SetObjectText("Expect1_txt","Expected Price","Comic Sans MS",7,LineStatus);
   MoveObject("Expect1_txt",OBJ_TEXT,Time[0]+Period()*60*3,Expect1,Time[0]+Period()*60*3,Expect1,LineStatus);
   //*****************************************************************************************           
   MoveObject("Expect2",OBJ_HLINE,Time[0],Expect2,Time[0],Expect2,LineStatus,1,STYLE_SOLID);
   SetObjectText("Expect2_txt","Expected Price","Comic Sans MS",7,LineStatus);
   MoveObject("Expect2_txt",OBJ_TEXT,Time[0]+Period()*60*3,Expect2,Time[0]+Period()*60*3,Expect2,LineStatus);
   //*****************************************************************************************           
   MoveObject("keyPrice",OBJ_HLINE,Time[0],keyPrice,Time[0],keyPrice,Gray,1,STYLE_SOLID);
   SetObjectText("keyPrice_txt","Key Price","Comic Sans MS",7,Gray);
   MoveObject("keyPrice_txt",OBJ_TEXT,Time[0]+Period()*60*3,keyPrice,Time[0]+Period()*60*3,keyPrice,Gray);
   //*****************************************************************************************           
   }
   else 
   {
   ObjectDelete("Expect1");
   ObjectDelete("Expect2");
   ObjectDelete("Expect1_txt");
   ObjectDelete("Expect2_txt");
   }
	return(0);
}

//*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*
double GetKeyPrice(double price)
{
	double d = MathRound(price / (extPips * Point));
	return(d * (extPips * Point) + (extPipsOffset * Point));
}
bool IsNear(double v1, double v2)
{
	double d = (v1 - v2) / Point;
	return(d >= -2 && d <= 2);
}
//+------------------------------------------------------------------+
//comment is like "1.2700_1.2730" means open price and tp price.
void TakePosition(double keyPrice)
{
	string comment_long = DoubleToStr(keyPrice, Digits) + "_" + DoubleToStr((keyPrice + extPips * Point), Digits);
	string comment_short = DoubleToStr(keyPrice, Digits) + "_" + DoubleToStr((keyPrice - extPips * Point), Digits);
	//Print ("long: " + comment_long + " ,short:  " + comment_short);
	bool no_same_long = true;
	bool no_same_short = true;
	for(int i = 0; i < OrdersTotal(); i++)
	{
		if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false)
		{
			Alert("OrderSelect retruned Error " + GetLastError());
			return(-1);
		}
		if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNo)
		{
		if(OrderComment() == comment_long) no_same_long = false;
		if(OrderComment() == comment_short) no_same_short = false;		
		}
	}
	
	double lot = GetLotSize();
	
	if(no_same_long)// && b==0
	{
		Print("no_same_long");
		hh=OrderSend(Symbol(), OP_BUY, RLot, Ask, Slippage, 0, Ask+extPips * Point, comment_long, MagicNo, 0, clOpenBuy);
		if(PlayAudio && hh>0)PlaySound("expert.wav");
	   else Print("LONG : ",ErrorDescription(GetLastError()));
	   exPositions=ExistPositions();
	   b++;
	}
	if(no_same_short)// && s==0
	{
		hh=OrderSend(Symbol(), OP_SELL, RLot, Bid, Slippage, 0, Bid-extPips * Point, comment_short, MagicNo, 0, clOpenSell);
		if(PlayAudio && hh>0)PlaySound("tick.wav");
		else Print("SHORT : ",ErrorDescription(GetLastError()));	
		exPositions=ExistPositions();
		s++;	
		Print("no_same_short");
	}
}

double GetLotSize()
{
	double unit =  (AccountBalance() * extSizeRatio) / (extPips * Point);
	double lot = NormalizeDouble(unit * 0.00001,1) ;
	return(lot);
}

void TakeProfit(double keyPrice)
{
	for(int i = 0; i < OrdersTotal(); i++)
	{
		if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false)
		{
			Alert("OrderSelect retruned Error " + GetLastError());
			return(-1);
		}
		if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNo)
		{
		 int pos = StringFind(OrderComment(), "_", 0);
		 double tp  = StrToDouble(StringSubstr(OrderComment(), pos + 1));
		
		 if (keyPrice == tp)
		 {
			 Print("tp = " + tp);
			 if(OrderType() == OP_BUY)
				 bool cb=OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clClose);
				 if(cb && PlayAudio)PlaySound("ok.wav");
				 else Print("Close BUY : ",ErrorDescription(GetLastError()));
			 if(OrderType() == OP_SELL)
				 bool cs=OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clClose);
		       if(cs && PlayAudio)PlaySound("ok.wav");	
		       else Print("Close SELL : ",ErrorDescription(GetLastError()));
		 }
		}
	}
}
//*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*
double Base(int MM)
{
 if(MM==1)return(AccountBalance());
 if(MM==2)return(AccountEquity());
 if(MM==3)return(AccountFreeMargin());
}
//*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*
double Lots(double risk)                                    // Calculation of lots
   {
    if(AutoLot)
    { if(risk>1)risk=1;
      //_________________________________________________________________________________________
      double Min_Lot = MarketInfo(Symbol(), MODE_MINLOT);   // Minimum permissible cost of lots
      double Max_Lot = MarketInfo(Symbol(), MODE_MAXLOT);   // Maximum permissible cost of lots
      double lot_step= MarketInfo(Symbol(), MODE_LOTSTEP);  // Step of increase or decrease lot
      Lot=NormalizeDouble(Base(MMBase)*risk/AccountLeverage()/10.0,2);
                                                            // Calculate the amoung of lots
      Lot=NormalizeDouble(Lot/lot_step,0)*lot_step;
      if (Lot < Min_Lot) Lot = Min_Lot;                     // For testing on const.min.lots
      if (Lot < MinLot)  Lot = MinLot;
      if (Lot > Max_Lot) Lot = Max_Lot;                     // For testing on const.max.lots
      if (Lot > MaxLot)  Lot = MaxLot;
      //_________________________________________________________________________________________
    }else Lot=LotSize;
   return(Lot);
   }
//*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*
bool SetObjectText(string name, string text, string font, int size, color Acolor)
{
   return(ObjectSetText(name, text, size, font, Acolor));
}

bool MoveObject(string name, int type, datetime Atime, double Aprice, datetime Atime2 = 0, 
                double Aprice2 = 0, color Acolor = CLR_NONE, int Aweight = 0, int Astyle = 0)
{
   if (ObjectFind(name) != -1) {
      int OType = ObjectType(name);

      if ((OType == OBJ_VLINE) ||
         (OType == OBJ_HLINE) ||
         (OType == OBJ_TRENDBYANGLE) ||
         (OType == OBJ_TEXT) ||
         (OType == OBJ_ARROW) ||
         (OType == OBJ_LABEL)) {
         return(ObjectMove(name, 0, Atime, Aprice));
      }

      if ((OType == OBJ_GANNLINE) ||
         (OType == OBJ_GANNFAN) ||
         (OType == OBJ_GANNGRID) ||
         (OType == OBJ_FIBO) ||
         (OType == OBJ_FIBOTIMES) ||
         (OType == OBJ_FIBOFAN) ||
         (OType == OBJ_FIBOARC) ||
         (OType == OBJ_RECTANGLE) ||
         (OType == OBJ_ELLIPSE) ||
         (OType == OBJ_CYCLES) ||
         (OType == OBJ_TREND) ||
         (OType == OBJ_STDDEVCHANNEL) ||
         (OType == OBJ_REGRESSION)) {
         return(ObjectMove(name, 0, Atime, Aprice) && ObjectMove(name, 1, Atime2, Aprice2));
      }
   }
   else {
      return(ObjectCreate(name, type, 0, Atime, Aprice, Atime2, Aprice2, 0, 0) 
            && ObjectSet(name, OBJPROP_COLOR, Acolor));
   }
}
//*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*
string bool2string(bool o)
{
 if(o) return("Yes");
 if(!o)return("No");
}
//*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*
string MMBase2string(int w)
{
 switch(w)
 {
  case 1:return("AccountBalance");break;
  case 2:return("AccountEquity");break;
  case 3:return("AccountFreeMargin");break;
 }
}
//*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*
int ExistPositions() 
{
   int NumofPositions=0;
   for(int i=0;i<OrdersTotal(); i++) 
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) &&
      OrderSymbol()==Symbol() &&OrderMagicNumber()==MagicNo){ NumofPositions++;}
   }
return (NumofPositions);
}/*
//*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*
double LiveOrder()
{     double OOP=0;
      for(int i=0;i<OrdersTotal();i++)
      {
       if(OrderSelect(i, SELECT_BY_POS,MODE_TRADES))
       {
        if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNo && OrderType()<2)
        {
          OOP++;
        }
       }
      }
return(OOP);
}*/
//*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*$*

